function BoardPage() {
    this.stageJson = {};
    this.index = 0;
    this.step = 0;
    this.stateHistory = [];
}
BoardPage.prototype.index = 0;
BoardPage.prototype.step = 0;
BoardPage.prototype.stateHistory = [];
BoardPage.prototype.stageJson = {};


var pageList = [];

var curPage = 0;
var pageTotal = 0;
var stage;
var layer;
var group;

//生成当前页的舞台数据
function buildStageInPage() {
	//如果当前页没有舞台
	if(!pageList[curPage]){
		// 创建舞台
        stage = new Konva.Stage({
            container: 'container',
            width: window.innerWidth,
            height: window.innerHeight,
            draggable: false,
            x: width / 2,
            y: height / 2,
            offset: {
                x: width / 2,
                y: height / 2
            }
        })
        if(layer){
            group.remove();
            group = null;
            layer.destroy();
            layer = null;
        }
        //创建绘图层
        layer = new Konva.Layer();
        //创建组
        group = new Konva.Group({
            draggable: false,
            width: window.innerWidth,
            height: window.innerHeight,
        });
        layer.add(group)
        stage.add(layer);
        pageTotal ++;
	}else{
		var stageJson = pageList[curPage].stageJson;
		// console.log(stageJson)
		//先销毁stage对象释放内存
		if (stage) {
	        stage.destroy();
	        stage = null;
	        layer = null;
	        group = null;
	    }
	    stage = Konva.Node.create(stageJson, 'container');
	}

	return stage;
}
//修改当前页的步数
function changePageStep(pageStep) {
	if(pageList[curPage]){
		var boardPage = pageList[curPage];
		boardPage.step = pageStep;
		pageList.splice(curPage,1,boardPage);
	}else{
		var  boardPage = new BoardPage();
		boardPage.step = 0;
		pageList.push(boardPage);
	}
}
//获取当前页的步数
function getPageStep() {
	var boardPage = pageList[curPage];
	// console.log('stateHistory:',boardPage.stateHistory);
	if(boardPage){
		return boardPage.step;
	}else{
		return 0;
	}
}
//获取当前页的历史步数
function getPageStateHistory(){
	
	var boardPage = pageList[curPage];
	if(boardPage){
		return boardPage.stateHistory;
	}else{
		return null;
	}
}
//添加历史绘画步骤
function addPageStateToHistory(pageGroup) {
    if (pageGroup) {
    	var boardPage;
    	if(pageList[curPage]){
    		boardPage = pageList[curPage];
    	}else{
    		boardPage = new BoardPage();
    		pageList.push(boardPage);
    	}
    	// console.log('boardPage.step:',boardPage.step,'boardPage.stateHistory.length',boardPage.stateHistory.length);
        //可能先撤回，再绘画。比如1-画一横；2-画一横；3-画一横；此时撤销一步，回到步骤2；此时继续画一竖，则应把前面的步骤3删掉，替换为新的步骤3
        if (boardPage.step < boardPage.stateHistory.length) {
            boardPage.stateHistory.splice(boardPage.step, boardPage.stateHistory.length - boardPage.step)
        }
        var json = pageGroup.toJSON()
        boardPage.step++
        // console.log('curpage:',curPage,'addStateToHistory pageStep:' + boardPage.step);
        boardPage.stateHistory.push(json);
        // console.log('boardPage:',boardPage);
        pageList.splice(curPage,1,boardPage);
    }
}
//后一页，此时要先保存当前页
function nextPageStage() {
	var stageJson = stage.toJSON();
	var boardPage = pageList[curPage];
	if(!boardPage){
		boardPage = new BoardPage();
		boardPage.stageJson = stageJson;
		pageList.push(boardPage);
	}else{
		boardPage.stageJson = stageJson;
		pageList.splice(curPage,1,boardPage);
	}
    
	curPage ++;
	return buildStageInPage();
}
//前一页，此时要先保存当前页
function prePageStage() {
    if (curPage > 0) {
    	var stageJson = stage.toJSON();
    	var boardPage = pageList[curPage];
    	if(!boardPage){//当前页还未添加，直接push
    		boardPage = new BoardPage();
    		boardPage.stageJson = stageJson;
			pageList.push(boardPage);
    	}else{//当前页添加过了，则替换
    		boardPage.stageJson = stageJson;
    		pageList.splice(curPage,1,boardPage);
    	}
    	
        curPage--;
        return buildStageInPage();
    }else{
    	return null;
    }
}
//获取页码
function getBoardPage(){
	let boardPageNum = JSON.stringify({
        "pageNum": curPage+1,
        "pageTotal": pageTotal
    });
	return boardPageNum;
}

//添加历史绘画步骤
function addStateToHistory() {
    if (group) {
        //可能先撤回，再绘画。比如1-画一横；2-画一横；3-画一横；此时撤销一步，回到步骤2；此时继续画一竖，则应把前面的步骤3删掉，替换为新的步骤3
        if (step < stateHistory.length) {
            stateHistory.splice(step, stateHistory.length - step)
        }
        var json = group.toJSON()
        step++
        console.log('addStateToHistory step:' + step);
        stateHistory.push(json)
    }
}


