// 判断是否是在移动设备
var isMobile = /Android|webOS|iPhone|iPod|BlackBerry/i.test(navigator.userAgent)
// 是否安卓设备
var isAndroid = /android/gi.test(navigator.appVersion)
// 是否IOS设备
var isIos = /(iPhone|iPad|mac|iPod|iOS)/gi.test(navigator.userAgent)
//判断是否是iOS WKWebview内核
var isWKWebview = window.__wxjs_is_wkwebview
// 触摸开始
function stageTouchDown(shape, ev) {
    if (curMode === 'drag') {
        return;
    }
    if (shape) {
        let x = ev.evt.offsetX,
            y = ev.evt.offsetY;
        pointStart = [x, y];
        stage.draggable = false;
        switch (shape) {
            case 'brush':
                // var pos = getRelativePointerPosition(group);
                freeDraw(pointStart);
                break;
            case 'star':
                // 星形
                drawStar(x, y);
                break;
            case 'rect':
                drawRect(x, y);
                break;
            case 'circle':
                //                drawText(x, y, graphColor, 16);
                drawCircle(x, y);
                break;
            case 'arrow':
                drawArrow(pointStart);
                break;
            case 'straightLine':
                drawStraightLine(pointStart);
                break;
            case 'triangle':
                drawTriangle(x, y);
                break;
            case 'text':
                drawText(x, y);
                break;
            default:
                break;
        }
        drawing = true;
        // curKonvaObj.on('touchmove',function(){
        //     if(curMode === 'erase'){
        //         this.remove()
        //         layer.batchDraw()
        //         addStateToHistory()
        //     }
        // })
    }
}

//触摸移动
function stageTouchMove(shape, ev) {
    if (!drawing) {
        return
    }
    if (shape) {
        switch (shape) {
            case 'brush':
                // const pos = stage.getPointerPosition()
                // var newPos = curKonvaObj.points().concat([pos.x, pos.y])
                // // console.log('move newpos:'+JSON.stringify(newPos))
                // curKonvaObj.points(newPos)
                pointStart.push(ev.evt.offsetX, ev.evt.offsetY);
                curKonvaObj.setAttrs({
                    points: pointStart
                });
                break;
            case 'rect':
                curKonvaObj.setAttrs({
                    width: ev.evt.offsetX - pointStart[0],
                    height: ev.evt.offsetY - pointStart[1]
                });
                break;
            case 'circle':
                curKonvaObj.setAttrs({
                    radius: Math.abs(ev.evt.offsetX - pointStart[0])
                });
                break;
            case 'arrow':
                // pointStart.push(ev.evt.offsetX, ev.evt.offsetY);
                pointStart.splice(2, 2, ev.evt.offsetX, ev.evt.offsetY);
                curKonvaObj.setAttrs({
                    points: pointStart,
                    pointerLength: paintWidth,
                    pointerWidth: paintWidth
                });
                break;
            case 'straightLine':
                pointStart.splice(2, 2, ev.evt.offsetX, ev.evt.offsetY);
                curKonvaObj.setAttrs({
                    points: pointStart
                });
                break;
            case 'star':
                curKonvaObj.setAttrs({
                    innerRadius: (Math.abs(ev.evt.offsetX - pointStart[0])) / 2,
                    outerRadius: Math.abs(ev.evt.offsetX - pointStart[0])
                });
                break;
            case 'triangle':
                curKonvaObj.setAttrs({
                    radius: Math.abs(ev.evt.offsetX - pointStart[0])
                });
                break;
        }
        layer.batchDraw()
    }
}

/**
 * 画刷-自由绘画
 * @param points 点数组
 * @param stroke 颜色
 * @param strokeWidth 线粗细
 */
function freeDraw(pos) {
    // var jsonEe = JSON.stringify(pos);
    const line = new Konva.Line({
        name: 'line',
        points: pos,
        stroke: brushColor,
        strokeWidth: brushWidth,
        lineCap: 'round',
        lineJoin: 'round',
        globalCompositeOperation: 'source-over',
        tension: 0.5,
        draggable: true,
        strokeScaleEnabled: false,
        hitStrokeWidth: paintWidth + 10,
    });
    curKonvaObj = line;
    group.add(line);
    layer.draw();
}
//绘制直线(freeDraw是自由绘制，线条不一定是直的)
function drawStraightLine(pos) {
    const straightLine = new Konva.Line({
        name: 'straightLine',
        points: pos,
        stroke: paintColor,
        strokeWidth: paintWidth,
        lineCap: 'round',
        lineJoin: 'round',
        globalCompositeOperation: 'source-over',
        tension: 0.5,
        draggable: true,
        strokeScaleEnabled: false
    });
    curKonvaObj = straightLine;
    group.add(straightLine);
    layer.draw();
}
//绘制箭头
function drawArrow(pos) {
    const arrow = new Konva.Arrow({
        name: 'arrow',
        x: 0,
        y: 0,
        points: pos,
        fill: paintColor,
        stroke: paintColor,
        strokeWidth: paintWidth / 2,
        pointerLength: 0,
        pointerWidth: 0,
        draggable: true

    });
    curKonvaObj = arrow;
    group.add(arrow);
    layer.draw();
}
//绘制矩形
function drawRect(x, y) {
    const rect = new Konva.Rect({
        name: 'rect',
        x: x,
        y: y,
        width: 0,
        height: 0,
        fill: null,
        stroke: paintColor,
        strokeWidth: paintWidth / 2,
        draggable: true,
        strokeScaleEnabled: false
    });
    curKonvaObj = rect;
    group.add(rect);
    layer.draw();
}
//绘制圆形
function drawCircle(x, y) {
    const circle = new Konva.Circle({
        name: 'circle',
        x: x,
        y: y,
        radius: 0,
        fill: null,
        stroke: paintColor,
        strokeWidth: paintWidth / 2,
        draggable: true,
        strokeScaleEnabled: false
    });
    curKonvaObj = circle;
    group.add(circle);
    layer.draw();
}
//绘制星形
function drawStar(x, y) {
    const star = new Konva.Star({
        name: 'star',
        x: x,
        y: y,
        innerRadius: 0,
        outerRadius: 0,
        fill: null,
        stroke: paintColor,
        strokeWidth: paintWidth / 2,
        draggable: true,
        strokeScaleEnabled: false
    });
    curKonvaObj = star;
    group.add(star);
    layer.draw();
}
//绘制三角形
function drawTriangle(x, y) {
    const triangle = new Konva.RegularPolygon({
        name: 'triangle',
        x: x,
        y: y,
        sides: 3,
        radius: 0,
        fill: null,
        stroke: paintColor,
        strokeWidth: paintWidth / 2,
        draggable: true,
        strokeScaleEnabled: false
    });
    curKonvaObj = triangle;
    group.add(triangle);
    layer.draw();
}

//绘制题目
function drawTopic(random, topicHtml) {
    if (!topicHtml.source || topicHtml.source === 0) {
        KMathJax.init(topicHtml.content).then((data) => {
            console.log('topic data:' + data)
            $("#topic-container").html(`<div >${data}</div`);

            //自定义标签处理，该示例未暂时自定义标签
            // KElement.render($("#topic-container")[0])

            var imgs = $("#topic-container").find("img");
            if (imgs && imgs.length > 0) {
                $.each(imgs, function(i, n) {
                    if (n.src && (n.src.startsWith('http') || n.src.startsWith('https'))) {
                        let img = new Image()
                        var url = n.src
                        var srcCanvas = document.createElement('canvas')
                        var ctx = srcCanvas.getContext('2d')
                        // img.setAttribute('crossOrigin', 'anonymous') ;
                        img.crossOrigin = 'Anonymous'; // 重点！设置image对象可跨域请求  
                        img.src = url + "?timeStamp=" + new Date().getTime(); //解决缓存引起访问失败需要添加时间戳。。。。。问题的关键点

                        img.onload = function() {
                            srcCanvas.height = img.height;
                            srcCanvas.width = img.width;
                            ctx.drawImage(img, 0, 0);
                            var dataURL = srcCanvas.toDataURL('image/jpeg');
                            n.src = dataURL
                            if (i == imgs.length - 1) {
                                setTimeout(() => {
                                    renderTopic(random);
                                }, 100);

                            }

                        };

                    } else if (n.src.startsWith('data:image/')) {
                        let img = new Image()
                        img.src = n.src
                        var srcCanvas = document.createElement('canvas')
                        var ctx = srcCanvas.getContext('2d')
                        img.onload = function() {
                            srcCanvas.height = img.height;
                            srcCanvas.width = img.width;
                            ctx.drawImage(img, 0, 0);
                            var dataURL = srcCanvas.toDataURL('image/jpeg');
                            n.src = dataURL
                            if (i == imgs.length - 1) {
                                setTimeout(() => {
                                    renderTopic(random);
                                }, 100);

                            }

                        };
                    }
                });
            } else {
                renderTopic(random);
            }
        })
    } else {
        topicHtml = topicHtml.content
        $("#topic-container").empty();
        var reg = /\$\$latex_yd(.+?)latex_yd\$\$/g;
        while ((result = reg.exec(topicHtml)) != null) {
            var rendered = katex.renderToString(result[1], {
                throwOnError: false
            });
            topicHtml = topicHtml.replace('\$\$latex_yd' + result[1] + 'latex_yd\$\$', rendered)
        }
        topicHtml = topicHtml.replace(/<br>/g, '\n<br>')
        $("#topic-container").append(topicHtml)

        setTimeout(() => {
            renderTopic(random);
        }, 100);
    }

}

function renderTopic(random) {
    html2canvas(document.getElementById('topic-container'), {
        backgroundColor: 'rgba(0,0,0,0)',
    }).then((canvas) => {
        // console.log('canvas img:'+canvas.toDataURL())
        // show it inside Konva.Image
        // console.log('add random:' + random)
        var topic = new Konva.Image({
            id: random,
            name: 'topic',
            x: 10,
            y: 50,
            image: canvas,
            draggable: true,
            scaleX: 1 / window.devicePixelRatio,
            scaleY: 1 / window.devicePixelRatio,
        });
        curKonvaObj = topic;
        group.add(topic);
        tr = new Konva.Transformer({
            borderStroke: '#ffd033', // 虚线颜色
            borderStrokeWidth: 1, //虚线大小
            borderDash: [5], // 虚线间距
            ignoreStroke: true,
            keepRatio: false, // 不等比缩放
            anchorStroke: '#ffd033',
            anchorSize: 16,
            anchorCornerRadius: 8
        });
        group.add(tr);
        tr.attachTo(topic);
        layer.draw();
        addStateToHistory();
        objMap[random] = canvas;
    });
}
//绘制图片
function drawImage(random, base64) {
    var imgObj = new Image();
    imgObj.src = base64;
    imgObj.onload = function() {
        var image = new Konva.Image({
            id: random,
            name: 'image',
            image: imgObj,
            x: 10,
            y: 50,
            scaleX: 1 / window.devicePixelRatio,
            scaleY: 1 / window.devicePixelRatio,
            draggable: true
        });
        curKonvaObj = image;
        group.add(image);
        tr = new Konva.Transformer({
            borderStroke: '#ffd033', // 虚线颜色
            borderStrokeWidth: 1, //虚线大小
            borderDash: [5], // 虚线间距
            ignoreStroke: true,
            keepRatio: false, // 不等比缩放
            anchorStroke: '#ffd033',
            anchorSize: 16,
            anchorCornerRadius: 8
        });
        group.add(tr);
        tr.attachTo(image);
        layer.draw();
        addStateToHistory();
        objMap[random] = imgObj;
    }
}
//绘制文字
function drawText(x, y) {
    const text = new Konva.Text({
        name: 'text',
        x: x,
        y: y,
        text: '',
        fontSize: 22,
        fontFamily: '微软雅黑',
        strokeWidth: 0.5,
        stroke: brushColor,
        fill: brushColor,
        draggable: true
    });
    curKonvaObj = text;
    group.add(text);
    layer.draw();
    drawTextArea(text);
    text.on('transform', function() {
        // reset scale, so only with is changing by transformer
        text.setAttrs({
            width: text.width() * text.scaleX(),
            scaleX: 1,
        });
    });
    text.on('dblclick dbltap', () => {
        curKonvaObj = text;
        setMode('text');
        drawTextArea(text);
    });
    // var textPosition = text.getAbsolutePosition();

    // // then lets find position of stage container on the page:
    // var stageBox = stage.container().getBoundingClientRect();
    // var areaPosition = {
    //     x: stageBox.left + textPosition.x,
    //     y: stageBox.top + textPosition.y,
    // };
    // xgj.addEditText(areaPosition.x, areaPosition.y);
}
var areaPosition;

function drawTextArea(textNode) {

    inputing = true;
    textNode.hide();
    stage.find('Transformer').hide();
    layer.draw();
    // create textarea over canvas with absolute position

    // first we need to find position for textarea
    // how to find it?

    // at first lets find position of text node relative to the stage:
    // var textPosition = textNode.getAbsolutePosition();
    var textPosition = getRelativePointerPosition(group); //textNode.getAbsolutePosition();
    // then lets find position of stage container on the page:
    var stageBox = stage.container().getBoundingClientRect();

    // so position of textarea will be the sum of positions above:
    areaPosition = {
        x: stageBox.left + textPosition.x,
        y: stageBox.top + textPosition.y,
    };
    console.log('areaPosition:', areaPosition)
    // create textarea and style it
    textarea = document.createElement('textarea');
    // if($('textarea')){
    //     $('textarea').remove();
    // }
    $("#box").append(textarea);
    textarea.placeholder = '请输入文字...';
    if (textNode.text() != '') {
        textarea.value = textNode.text();

    } else {
        textarea.placeholder = '请输入文字...';
    }

    textarea.style.position = 'fixed';
    textarea.style.top = areaPosition.y + 'px';
    textarea.style.left = areaPosition.x + 'px';
    textarea.style.width = 300 + 'px';
    textarea.style.height = 100 + 'px';


}
if (isAndroid) {
    var originHeight = document.documentElement.clientHeight || document.body.clientHeight;
    window.addEventListener('resize', function() {
        var resizeHeight = document.documentElement.clientHeight || document.body.clientHeight;
        if (originHeight < resizeHeight) {
            console.log('Android 键盘收起啦！');
            textarea.style.top = areaPosition.y + 'px';

        } else {
            console.log('Android 键盘弹起啦！');
            console.log('area y:', areaPosition.y, '    resizeHeight:', resizeHeight);
            if (areaPosition.y > resizeHeight) {
                textarea.style.top = (resizeHeight - 20) + 'px';
            }

        }

        originHeight = resizeHeight;
    }, false)
}

function drawHistoryBack(pageStep, pageStateHistory, callback) {
    if (pageStep > 1) {
        pageStep--;
        callback(pageStep);
        console.log('drawHistoryBack :' + pageStep);
        group.remove();
        group = Konva.Node.create(pageStateHistory[pageStep - 1], null);
        // console.log('drawHistoryBack group is:',pageStateHistory[pageStep - 1]);
        var nodes = group.find(node => {
            return node.getClassName() === 'Image';
        });
        nodes.forEach(function(node) {
            var obj = new Function("return" + node.toJSON())();
            var id = obj.attrs.id;
            node.image(objMap[id]);
        })
        layer.add(group);
        layer.batchDraw();
    } else if (pageStep == 1) {
        pageStep--;
        callback(pageStep);
        group.removeChildren();
        layer.batchDraw();
    } else {
        console.log('已经是第一页了')
    }
}
//绘制后一个状态-前进
function drawHistoryGo(pageStep, pageStateHistory, callback) {
    if (pageStep < pageStateHistory.length) {
        pageStep++;
        callback(pageStep);
        group.remove();
        group = Konva.Node.create(pageStateHistory[pageStep - 1], null);
        var nodes = group.find(node => {
            return node.getClassName() === 'Image';
        });
        nodes.forEach(function(node) {
            var obj = new Function("return" + node.toJSON())();
            var id = obj.attrs.id;
            node.image(objMap[id]);
        })
        layer.add(group)
        stage.add(layer)
        layer.batchDraw()
    }
}
//绘制前一个状态-撤销
function drawHistoryBack1() {
    if (step > 1) {
        step--;
        console.log('drawHistoryBack :' + step);
        group.remove();
        group = Konva.Node.create(stateHistory[step - 1], null);
        var nodes = group.find(node => {
            return node.getClassName() === 'Image';
        });
        nodes.forEach(function(node) {
            var obj = new Function("return" + node.toJSON())();
            var id = obj.attrs.id;
            node.image(objMap[id]);
        })
        layer.add(group);
        layer.batchDraw();
    } else if (step == 1) {
        step--;
        group.removeChildren();
        layer.batchDraw();
    } else {
        console.log('已经是第一页了')
    }
}
//绘制后一个状态-前进
function drawHistoryGo1() {
    if (step < stateHistory.length) {
        step++;
        // console.log('drawHistoryGo step:'+step);
        // console.log('drawHistoryGo :'+JSON.stringify(stateHistory[step-1]));
        group.remove();

        group = Konva.Node.create(stateHistory[step - 1], null);
        var nodes = group.find(node => {
            return node.getClassName() === 'Image';
        });
        nodes.forEach(function(node) {
            var obj = new Function("return" + node.toJSON())();
            var id = obj.attrs.id;
            node.image(objMap[id]);
        })

        // group.children.forEach(function(node){
        //     // console.log('group nodes:'+node.toJSON())
        //     if(node.hasName('topic')){
        //         var obj = new Function("return" + node.toJSON())();
        //         var id = obj.attrs.id;
        //         group.findOne('#'+id).image(objMap[id]);
        //     }
        // })

        layer.add(group)
        stage.add(layer)
        layer.batchDraw()
    }
}