/**
 * 数学公式转换
 * stemData 公式处理之前的数据
 * NewStemData 公式处理过后的数据
 * 调用方式，例  
 * KMathJax.init(stemData).then((NewStemData)=>{
 *          NewStemData //公式处理过后的数据
 *  })
 */
(function (global) {
    var KMathJax = global.KMathJax = {};
    /**
     * 题目图片配置
     */
    var ImgConfig =  {
        '/goodteacher_api/': 'https://cp.51polestar.com/goodteacher_api/',
        '/goodteacherImg/': 'https://polaris-bucket.oss-cn-shanghai.aliyuncs.com/goodteacherImg/',
        '/gtImg/': 'https://polaris-img-bucket.oss-cn-shanghai.aliyuncs.com/gtImg/',
        '/gtFile/': 'https://polaris-bucket.oss-cn-shanghai.aliyuncs.com/gtFile/',
    }
    /**
     * 需要转义的网页符号对应关系
     */
    var map = {
        '&#xff1d;': '=',
        '&#xff1b;': '；',
        '&#xff1e;': '>',
        '&#xff1c;': '<',
        '&#xff0c;': '，',
        '&#xff1a;': '：',
        '&#xff0e;': '.',
        '&#09;': '---',
        '&#10;': '---',
        '&#13;': '---',
        '&#160;': ' ',
        '&#33;': '!',
        '&#34;': '\\"',
        '&#35;': '#',
        '&#36;': '$',
        '&#37;': '%',
        '&#38;': '&',
        '&#39;': '\'',
        '&#40;': '(',
        '&#41;': ')',
        '&#42;': '*',
        '&#43;': '+',
        '&#44;': ',',
        '&#45;': '-',
        '&#46;': '.',
        '&#47;': '/',
        '&#48;': '0',
        '&#49;': '1',
        '&#50;': '2',
        '&#51;': '3',
        '&#52;': '4',
        '&#53;': '5',
        '&#54;': '6',
        '&#55;': '7',
        '&#56;': '8',
        '&#57;': '9',
        '&#58;': ':',
        '&#59;': ';',
        '&#60;': '<',
        '&#61;': '=',
        '&#62;': '>',
        '&#63;': '?',
        '&#64;': '@',
        '&#65;': 'A',
        '&#66;': 'B',
        '&#67;': 'C',
        '&#68;': 'D',
        '&#69;': 'E',
        '&#70;': 'F',
        '&#71;': 'G',
        '&#72;': 'H',
        '&#73;': 'I',
        '&#74;': 'J',
        '&#75;': 'K',
        '&#76;': 'L',
        '&#77;': 'M',
        '&#78;': 'N',
        '&#79;': 'O',
        '&#80;': 'P',
        '&#81;': 'Q',
        '&#82;': 'R',
        '&#83;': 'S',
        '&#84;': 'T',
        '&#85;': 'U',
        '&#86;': 'V',
        '&#87;': 'W',
        '&#88;': 'X',
        '&#89;': 'Y',
        '&#90;': 'Z',
        '&#91;': '[',
        '&#92;': '/',
        '&#93;': ']',
        '&#94;': '^',
        '&#95;': '_',
        '&#96;': '`',
        '&#97;': 'a',
        '&#98;': 'b',
        '&#99;': 'c',
        '&#100;': 'd',
        '&#101;': 'e',
        '&#102;': 'f',
        '&#103;': 'g',
        '&#104;': 'h',
        '&#105;': 'i',
        '&#106;': 'j',
        '&#107;': 'k',
        '&#108;': 'l',
        '&#109;': 'm',
        '&#110;': 'n',
        '&#111;': 'o',
        '&#112;': 'p',
        '&#113;': 'q',
        '&#114;': 'r',
        '&#115;': 's',
        '&#116;': 't',
        '&#117;': 'u',
        '&#118;': 'v',
        '&#119;': 'w',
        '&#120;': 'x',
        '&#121;': 'y',
        '&#122;': 'z',
        '&#123;': '｛',
        '&#124;': '|',
        '&#125;': '｝',
        '&#126;': '~',
        '&#127;': '---',
        '&#161;': '?',
        '&#162;': '￠',
        '&#163;': '￡',
        '&#164;': '¤',
        '&#165;': '￥',
        '&#166;': '|',
        '&#167;': '§',
        '&#168;': '¨',
        '&#169;': '?',
        '&#170;': 'a',
        '&#171;': '?',
        '&#172;': '?',
        '&#173;': '¬',
        '&#174;': '?',
        '&#175;': 'ˉ',
        '&#176;': '°',
        '&#177;': '±',
        '&#178;': '2',
        '&#179;': '3',
        '&#180;': '′',
        '&#181;': 'μ',
        '&#182;': '?',
        '&#183;': '•',
        '&#184;': '?',
        '&#185;': '1',
        '&#186;': 'o',
        '&#187;': '?',
        '&#188;': '?',
        '&#189;': '?',
        '&#190;': '?',
        '&#191;': '?',
        '&#192;': 'à',
        '&#193;': 'á',
        '&#194;': '?',
        '&#195;': '?',
        '&#196;': '?',
        '&#197;': '?',
        '&#198;': '?',
        '&#199;': '?',
        '&#200;': 'è',
        '&#201;': 'é',
        '&#202;': 'ê',
        '&#203;': '?',
        '&#204;': 'ì',
        '&#205;': 'í',
        '&#206;': '?',
        '&#207;': '?',
        '&#208;': 'D',
        '&#209;': '?',
        '&#210;': 'ò',
        '&#211;': 'ó',
        '&#212;': '?',
        '&#213;': '?',
        '&#214;': '?',
        '&#215;': '×',
        '&#216;': '?',
        '&#217;': 'ù',
        '&#218;': 'ú',
        '&#219;': '?',
        '&#220;': 'ü',
        '&#221;': 'Y',
        '&#222;': 'T',
        '&#223;': '?',
        '&#224;': 'à',
        '&#225;': 'á',
        '&#226;': 'a',
        '&#227;': '?',
        '&#228;': '?',
        '&#229;': '?',
        '&#230;': '?',
        '&#231;': '?',
        '&#232;': 'è',
        '&#233;': 'é',
        '&#234;': 'ê',
        '&#235;': '?',
        '&#236;': 'ì',
        '&#237;': 'í',
        '&#238;': '?',
        '&#239;': '?',
        '&#240;': 'e',
        '&#241;': '?',
        '&#242;': 'ò',
        '&#243;': 'ó',
        '&#244;': '?',
        '&#245;': '?',
        '&#246;': '?',
        '&#247;': '÷',
        '&#248;': '?',
        '&#249;': 'ù',
        '&#250;': 'ú',
        '&#251;': '?',
        '&#252;': 'ü',
        '&#253;': 'y',
        '&#254;': 't',
        '&#255;': '?'
    }
    /***
     * 公式预处理
     */
    function formulaPretreatment(str) {
        var reg = /(<span id=\\"\d{13}_katex\\" class=\\"mathquill-static-math mq-math-mode\\" contenteditable=\\"false\\">)|(<span)|(<\/span>)/g;
        var start = -1,
            end, count, match, result = [];
        while ((match = reg.exec(str)) !== null) {
            if (match[1]) {
                start = match.index + match[1].length;
                count = 1;
            } else if (start !== -1 && match[2]) {
                count++;
            } else if (start !== -1 && match[3]) {
                count--;
                if (count == 0) {
                    end = match.index;
                    result.push(str.substring(start, end));
                    start = -1;
                }
            }
        }
        for (var i = 0; i < result.length; i++) {
            var formulaReg = /<span class=\\"mq-selectable\\">\$(.*?)\$<\/span>/;
            var formulaStr = formulaReg.exec(result[i])[1];
            var formula = '<k-math data-k-element-rule=\\"' + formulaStr.replace(/&amp;/g, '&').replace(/&lt;/g, '<').replace(/&gt;/g, '>') + '\\"></k-math>';
            str = str.replace(result[i], formula);
        }
        return str;
    }

    /**
     * 加载配置配置文件
     * @param {String} search 
     * @param {String} replace 
     * @returns 
     */
    String.prototype.replaceAll = function (search, replace) {
        return this.split(search).join(replace);
    }

    /**
     * latex公式转换
     * @param {Object} stemData  //题目数据
     * 
     */
    KMathJax.init = function (stemData) {
        return new Promise(function (resolve) {
            stemData = JSON.stringify(stemData);
            stemData = formulaPretreatment(stemData);
            stemData = JSON.parse(stemData.replace(/k-img data-k-element-rule/g, 'img src').replace(/><\/k-img>/g, '/>').replace(/&nbsp;?/gmi, " ").replace(/&nbsp; /gmi, " "))
            var data = JSON.stringify(stemData).replace(/(&#.+?;)/g, function (math, $1) {
                return map[$1] || ''
            });
            // Log.info('处理之前的数据1',stemData);
            
            //公式自定义标签
            var reg = /<k-math data-k-element-rule=(.+?)><\/k-math>/g;
            //图片处理
            var ImgReg = /<img src=(.+?)>/g;
            // console.log('result-----------------',data)
            //其他公式
            var OtherReg = /(\\\\(?=\(|\[)|\$\$).+?(\\\\(?=\)|\])(\)|\])|\$\$)/g;
            var resultArray = [];
            var mathArray = [];
            var result = null;
            var set = {};
            //图片处理
            while ((result = ImgReg.exec(data)) != null) {
                if(result[0].indexOf('http://') == -1 && result[0].indexOf('https://') == -1 && result[0].indexOf('data:image') == -1) {
                    for (const key in ImgConfig) {
                        if (Object.hasOwnProperty.call(ImgConfig, key)) {
                            if(result[1].indexOf(key) != -1) {
                                var newImg = result[0].replace(key,ImgConfig[key])
                                // console.log(data.replace(result[0],newImg));
                                 data = data.replace(result[0],newImg)
                            }
                        }
                    }
                }
            }
            stemData = JSON.parse(data)
  
            //取其他公式latex文本
            while ((result = OtherReg.exec(data)) != null) {
                var math = result[0].replace(/\$\$/g, '').replace(/\\\\(?=\()\(/g, '').replace(/\\\\\)/g, '').replace(/\\\\(?=\[)\[/g, '').replace(/\\\\\]/g, '').replace(/\\\\±/g, '±').replace(/&amp;/g, '&').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/\\\\/g, '\\');
                resultArray.push(result);
                mathArray.push(math);
            }
            //取自定义标签公式latex文本
            while ((result = reg.exec(data)) != null) {
                var math = result[1].replace(/\\'/g, '').replace(/\\"/g, '').replace(/'/g, '').replace(/"/g, '').replace(/\\\\/g, '\\').replace(/（/g, '(').replace(/）/g, ')').replace(/~/g, '～').replace(/&nbsp[;]?/g, ' ');
                if (!set[math]) {
                    set[math] = 1;
                    resultArray.push(result);
                    mathArray.push(math);
                }
            }
            if (mathArray.length > 0) {
                // 分段处理
                var mathStrArray = [],
                    mathStr = '',
                    maxUrlLength = 1024;
                for (var i = 0; i < mathArray.length; i++) {
                    if (mathStr.length - 2 + mathArray[i].length <= maxUrlLength) {
                        mathStr += mathArray[i] + '@@';
                    } else {
                        mathStrArray.push(mathStr.substring(0, mathStr.length - 2));
                        mathStr = mathArray[i] + '@@';
                    }
                }
                mathStrArray.push(mathStr.substring(0, mathStr.length - 2));

                var count = 0,
                    tmpSvgArray = [];
                for (var j = 0; j < mathStrArray.length; j++) {
                    (function (index) {
                        var mathStr = mathStrArray[j];
                        var xhr = new XMLHttpRequest();
                        xhr.open("GET", "https://cp.51polestar.com/goodteacher_api/formula/display/batch/svg?math=" + encodeURIComponent(mathStr), true);
                        xhr.send();
                        xhr.onreadystatechange = function (response) {
                            // console.log("response--------", response);
                            if (xhr.readyState == 4 && xhr.status == 200) {
                                var svgArray = JSON.parse(xhr.response); //获取到json字符串，还需解析
                                tmpSvgArray[index] = svgArray;
                                count++;
                                if (count == mathStrArray.length) {
                                    svgArray = [];
                                    for (var i = 0; i < tmpSvgArray.length; i++) {
                                        svgArray = svgArray.concat(tmpSvgArray[i]);
                                    }
                                    for (var i = 0; i < resultArray.length; i++) {
                                        if (svgArray[i] != 'error') {
                                            data = data.replaceAll(resultArray[i][0], "<span data-k-element-type='math' data-k-element-rule=" + resultArray[i][1] + " contenteditable='false'>" + svgArray[i].replace(/"/g, "'").replace(/\\/g, '\\\\').replace(/[\r\n\t]/g, "") + "</span>");
                                        }
                                    }
                                    // console.log(JSON.parse(data));
                                    resolve(JSON.parse(data))
                                }
                            }
                        };
                    }(j));
                }
            } else {
                console.log(stemData);
                resolve(stemData)
            }
        })
    };
}(window));

