var callbackIds = 0;
var lastDist = 0;
var lastCenter = null;
//生成函数名
function getFnName(fnName) {
    callbackIds++;
    return 'window_protocal' + Date.now() + '_' + fnName + '$' + callbackIds + '';
}
//获取两个触摸点之间的距离
function getDistance(p1, p2) {
    return Math.sqrt(Math.pow(p2.x - p1.x, 2) + Math.pow(p2.y - p1.y, 2));
}
//获取中心点
function getCenter(p1, p2) {
    return {
        x: (p1.x + p2.x) / 2,
        y: (p1.y + p2.y) / 2,
    };
}
//基于中心的缩放
function scaleFromCenter1(touch1, touch2, stage) {
    var p1 = {
        x: touch1.clientX,
        y: touch1.clientY,
    };
    var p2 = {
        x: touch2.clientX,
        y: touch2.clientY,
    };

    if (!lastCenter) {
        lastCenter = getCenter(p1, p2);
        return;
    }
    var newCenter = getCenter(p1, p2);

    var dist = getDistance(p1, p2);

    if (!lastDist) {
        lastDist = dist;
    }

    // local coordinates of center point
    var pointTo = {
        x: (newCenter.x - stage.x()) / stage.scaleX(),
        y: (newCenter.y - stage.y()) / stage.scaleX(),
    };

    var scale = stage.scaleX() * (dist / lastDist);

    stage.scaleX(scale);
    stage.scaleY(scale);
    // stage.width(stage.width()*scale);
    // stage.height(stage.height()*scale);

    // calculate new position of the stage
    var dx = newCenter.x - lastCenter.x;
    var dy = newCenter.y - lastCenter.y;

    var newPos = {
        x: newCenter.x - pointTo.x * scale + dx,
        y: newCenter.y - pointTo.y * scale + dy,
    };
    stage.position(newPos);
    lastDist = dist;
    lastCenter = newCenter;
    stage.batchDraw();
    lastDist = dist;
}
//获取相对位置(移动和缩放时会引起坐标系变换)
function getRelativePointerPosition(node) {
    // the function will return pointer position relative to the passed node
    var transform = node.getAbsoluteTransform().copy();
    // to detect relative position we need to invert transform
    transform.invert();

    // get pointer (say mouse or touch) position
    var pos = node.getStage().getPointerPosition();

    // now we find relative point
    return transform.point(pos);
}

//添加历史绘画步骤
function addStateToHistory() {
    if (group) {
        //可能先撤回，再绘画。比如1-画一横；2-画一横；3-画一横；此时撤销一步，回到步骤2；此时继续画一竖，则应把前面的步骤3删掉，替换为新的步骤3
        if (step < stateHistory.length) {
            stateHistory.splice(step, stateHistory.length - step)
        }
        var json = group.toJSON()
        step++
        console.log('addStateToHistory step:' + step);
        stateHistory.push(json)
    }
}


/**清除图片背景颜色 **/
function removeImgBg(img) {
    //背景颜色  白色
    const rgba = [255, 255, 255, 255];
    // 容差大小
    const tolerance = 60;
 
    var imgData = null;
    const [r0, g0, b0, a0] = rgba;
    var r, g, b, a;
    const canvas = document.createElement('canvas');
    const context = canvas.getContext('2d');
    const w = img.width;
    const h = img.height;
 
 
    canvas.width = w;
    canvas.height = h;
    context.drawImage(img, 0, 0);
    imgData = context.getImageData(0, 0, w, h);
 
    for (let i = 0; i < imgData.data.length; i += 4) {
        r = imgData.data[i];
        g = imgData.data[i + 1];
        b = imgData.data[i + 2];
        a = imgData.data[i + 3];
        const t = Math.sqrt((r - r0) ** 2 + (g - g0) ** 2 + (b - b0) ** 2 + (a - a0) ** 2);
        if (t <= tolerance) {
            imgData.data[i] = 0;
            imgData.data[i + 1] = 0;
            imgData.data[i + 2] = 0;
            imgData.data[i + 3] = 0;
        }
    }
    context.putImageData(imgData, 0, 0);
    const newBase64 = canvas.toDataURL('image/png');
    img.src = newBase64;
}
