//生成复习计划每一项题目的底部标签
function buildReviewPlanTag(stemObj){
    let completedTimes = stemObj.completeTimes ? stemObj.completeTimes : 0
    let completeTimesTag =  `<span id="review-times-${stemObj.id}" class="infotag">已完成${completedTimes}次复习</span>`//buildInfoTag('已完成'+completedTimes+'次复习')
    let statusTag = ''
    switch(stemObj.status){
        case 0:
            if(stemObj.type === 1){
                statusTag = buildDefaultTag(stemObj.id,stemObj.companyId)
            }else{
                statusTag = ''
            }
            
            break;
        case 1:
            statusTag = buildCompletedTag()
            break;
        case 2:
            statusTag = buildGraspedTag()
            break;
        default:
            statusTag = buildDefaultTag(stemObj.id,stemObj.companyId)
    }
    return completeTimesTag +  `<div id="review-status-${stemObj.id}" class="right">${statusTag}</div>`
}
//默认状态(待完成)
function buildDefaultTag(id,companyId){
    let completeTxt = `<span class="operation-btntag-txt">完成复习</span>`;
    let compteleBtn = `<div class="operation-btntag-box"  onclick="completeReviewClick(${id},${companyId})">${completeTxt}</div>`;
    return compteleBtn
}
//已完成状态
function buildCompletedTag(){
    let rewardTag = `<img  src="../images/reward.png" style="width:24px;height:24px;margin-right:5px"/>`;

    return  rewardTag + `<span class="infotag" >已完成复习</span>`
}
//已掌握状态
function buildGraspedTag(){
    let graspedStatusTag = `<span class="infotag" style="color:#13c25b">已掌握</span>`
    return graspedStatusTag;
}
function completeReviewClick(taskId,companyId){
    var fnName = getFnName('completeReview')
    console.log('fnName:',fnName)
    window[fnName] = function(res) {
        res.data.taskId = taskId
        completeReviewCallback(res,companyId);
        delete window[fnName];
    }
    let requestAppParam = JSON.stringify({
        "companyId":companyId,
        "taskId": taskId,
        "result": fnName
    });
    console.log('request app param:',requestAppParam)
    if (isIos) {
        try{
            window.webkit.messageHandlers.completeReview.postMessage(requestAppParam);
        }catch(e){
            console.log('call ios function error:',e)
        }
    } else {
        try{
            xgj.completeReview(requestAppParam);
        }catch(e){
            console.log('call android function error:',e)
        }   
       
    }
}

function completeReviewCallback(res,companyId){
    let result = JSON.parse(JSON.stringify(res))
    if (result.code === 1) {
        let timesId = "#review-times-" + result.data.taskId
        let statusId = "#review-status-" + result.data.taskId;
        $(timesId).html('已完成'+result.data.completeTimes+'次复习')
        $(statusId).empty()
        let statusTag = ''
        switch(result.data.status){
            case 0:
                statusTag = buildDefaultTag(result.data,companyId)
                break;
            case 1:
                statusTag = buildCompletedTag()
                break;
            case 2:
                statusTag = buildGraspedTag()
                break;
            default:
                statusTag = buildDefaultTag(result.data,companyId)
        }
        $(statusId).append(statusTag)
    } 
}
function batchCompleteReviewOld(reviewTasks){
    $.each(reviewTasks, function(i, task) {
        let res = {code:1,data:task}
        completeReviewCallback(res,0)
    });
}