var isMobile = /Android|webOS|iPhone|iPod|BlackBerry/i.test(navigator.userAgent)
// 是否安卓设备
var isAndroid = /android/gi.test(navigator.appVersion)
// 是否IOS设备
var isIos = /(iPhone|iPad|mac|iPod|iOS)/gi.test(navigator.userAgent)
//判断是否是iOS WKWebview内核
var isWKWebview = window.__wxjs_is_wkwebview
//是否需要勾选按钮
var showCheckbox = false
//已勾选的题目数量
var stemChooseNum = 0
//已勾选的题目
var chooseStems = []

var stemMap = {}
//待组卷题目
var paperStems = []

function loadStem(stemList,type,isReload) {
    let body = ""
    $.each(stemList, function(i, n) {
        body += buildTopicItemView(n,type)
    })
    KMathJax.init(body).then((data) => {
        if (isReload) {
            $("#stem-container").empty();
            if(type === 'p2' || type === 't1'){
                // if(chooseStems && chooseStems.length > 0){
                //     stemChooseNum=chooseStems.length;
                // }else{
                    chooseStems = []
                    stemChooseNum=0
                    setTotalStem(0)
                // }
            }
            if(type === 'p3'){
                paperStems = stemList
                if(paperStems && paperStems.length > 0){
                    setTotalStem(paperStems.length)
                }else{
                    setTotalStem(0)
                }
            }
        }
        $("#stem-container").append(data);
       checkEvent(type)
        if (isIos) {
            try{
                window.webkit.messageHandlers.setWebHeight.postMessage(document.body.scrollHeight);
            }catch(e){
                console.log('call ios function error:',e)
            }
        }
    });
}

function loadStemWithGroup(stemGroupList,type,date){
    $("#stem-container").empty()
    $.each(stemGroupList, function(i, stemGroupObj) {
        
        $("#stem-container").append(buildStemGroupItem(stemGroupObj))
        loadStemInGroup(stemGroupObj,type,date)
    })
}

function loadStemInGroup(stemGroupObj,dayType,date){
    let body = ''
    $.each(stemGroupObj.reviewPlanList,function(i,stemObj){
        stemObj.dayType = dayType
        // let  tagsBar = renderBar("p4",stemObj)
        // let stemIem = buildStemInGroup(stemObj,tagsBar)
        let stemIem = buildStemInGroup(stemObj,dayType,date)
        body += stemIem
        
    })
    KMathJax.init(body).then((data) => {
        let groupContainerId = "#stem-group-container-" + stemGroupObj.subjectId
        $(groupContainerId).append(data)
        preventDefault(".operation-btntag-box")
    })
}

function checkEvent(type){
    if(type === "p1" || type === 'p3'){
        preventDefault(".operation-btntag-box")
    }
    // if(type === "p3"){
    //     // preventDefault(".item-delete")
    //     preventDefault(".operation-btntag-box")
    // }
    if(type === "p2"){
        preventDefault(".detail-btntag")
    }
    if(type === "t1"){
        preventDefault(".knowledgeTag")
        preventDefault(".noKnowledgeTag")
    }
}
function preventDefault(selector){
    $(selector).each(function(i, n) {
        $(this).click((e) => {
            e.stopPropagation();
        })
    })
}

function buildTopicItemView(stemObj,type) {
    stemMap[stemObj.questionId] = stemObj
    curType = type
    let  tagsBar = renderBar(type,stemObj)
    let stemIem = renderStemItem(type,stemObj,tagsBar)
    return stemIem
}

//点击某道题目
function clickStem(questionId,x3TeacherId,questionStudentId) {
    let requestAppParam = JSON.stringify({
        "questionId": questionId,
        "x3TeacherId": x3TeacherId === 'undefined' ? '' : x3TeacherId,
        "questionStudentId": questionStudentId === 'undefined' ? '' :questionStudentId
    })
    // console.log('requestappparam:',requestAppParam)
    if (isIos) {
        try{
            window.webkit.messageHandlers.clickStem.postMessage(requestAppParam);
        }catch(e){
            console.log('call ios function error:',e)
        }
    } else {
        try{
            xgj.clickStem(requestAppParam);
        }catch(e){
            console.log('call android function error:',e)
        }
    }
    return false;
}
 //清空勾选计数
 function clearCountStem(){
    getChooseStems();
    if(chooseStems && chooseStems.length > 0){

        $.each(chooseStems,function(i,chooseStem){
            let sid = ''
            if(chooseStem.questionRelationId){
                sid = chooseStem.questionRelationId
            }else{
                sid = chooseStem.questionId
            }
            var ids = "#" + sid;
            if ($(ids).prop("checked")) {
                $(ids).attr("checked", false);
            }
        });
    }
    stemChooseNum=0;
    setTotalStem(0);
    chooseStems = [];
    
}
function chooseStem(questionId){
    var ids = "#" + questionId;
    if ($(ids).prop("checked")) {
        $(ids).attr("checked", false);
        if(stemChooseNum > 0){
            stemChooseNum -- ;
        }
    } else {
        $(ids).attr("checked", true);
        stemChooseNum ++;
    }
    setTotalStem(stemChooseNum);
}
function setTotalStem(chooseNum) {
    let allCount =$(".checkbox-parent").length
    let requestAppParam = JSON.stringify({
        "total": chooseNum,//选中总数
        "allCount":allCount//所有可勾选数量
    });
    if(isMobile){
        if (isIos) {
            try{
                window.webkit.messageHandlers.setTotalStem.postMessage(requestAppParam);
            }catch(e){
                console.log('call ios function error:',e)
            }
        } else {
            try{
                xgj.setTotalStem(requestAppParam);
            }catch(e){
                console.log('call android function error:',e)
            }   
           
        }
    }
}

//获取选中的题目列表
function getChooseStems(){
    let stemList = [];
    if(chooseStems && chooseStems.length > 0){
        chooseStems.splice(0,chooseStems.length);
    }
    var allStem = $('[name=cb]');
    for(var i=0;i<allStem.length;i++){
        if(allStem[i].checked){
            stemList.push(stemMap[allStem[i].id])
            chooseStems.push(stemMap[allStem[i].id])
        }
    }

    return stemList;
}


var similarMap = []
//渲染相似题
function similarCallback(res, questionId){
    let result = JSON.parse(JSON.stringify(res))
    if (result.code === 1) {
        let similarObj = result.data
        // console.log('similarObj:',JSON.stringify(similarObj))
        if(!similarObj){
            console.log('未找到相似题')
            return
        }
        if (similarMap[questionId]) {
            if (similarMap[questionId].length >= 5) {
                console.log('最多生成5道相似题');
                h5CallAppShowToast('最多生成5道相似题')
                return;
            } else {
                //需先判断该相似题是否已经生成过了
                let generated = false;
                $.each(similarMap[questionId], function(i, generatedSimilar) {
                    if (similarObj.stemId && similarObj.stemId === generatedSimilar.stemId) {
                        generated = true
                        return false
                    }
                });
                if (generated) {
                    console.log('该相似题已存在，请尝试重新生成');
                    h5CallAppShowToast('该相似题已存在，请尝试重新生成')
                    return
                } else {
                    let similarNumber = similarMap[questionId].length + 1
                    let similarItem = buildSimilarStem(similarObj,questionId,similarNumber)
                    let id = getSimilarInsertId(questionId)
                    $(id).after(similarItem)
                    similarMap[questionId].push(similarObj)
                }
            }
        }else{
            let similarItem = buildSimilarStem(similarObj,questionId,1)
            let id = getSimilarInsertId(questionId)
            $(id).after(similarItem)
            similarMap[questionId] = [];
            similarMap[questionId].push(similarObj)
        }
        insertToPaperArray(similarObj,questionId)
        setTotalStem(paperStems.length)
    }
}
//获取相似题插入的位置
function getSimilarInsertId(origQuestionId){
    let id = ''
    if(similarMap[origQuestionId] && similarMap[origQuestionId].length > 0){
        let similarLength = similarMap[origQuestionId].length
        let preSimilarItem = similarMap[origQuestionId][similarLength - 1]
        id = '#similaritem' + origQuestionId + preSimilarItem.stemId
    }else{
        id = '#stemitem' + origQuestionId
    }
    return id
}
//将相似题插入数组
function insertToPaperArray(similarObj,origQuestionId){
    $.each(paperStems,function(i,stemObj){
        if(stemObj.questionId && stemObj.questionId === origQuestionId){
            if(similarMap[origQuestionId] && similarMap[origQuestionId].length > 0){
                paperStems.splice(i+1+similarMap[origQuestionId].length,0,similarObj)
            }else{
                paperStems.splice(i+1,0,similarObj)
            }
            return false
        }
    });
}
//获取组卷题目
function generatePaper(){
    // console.log(JSON.stringify(paperStems));
    var paper = []
    $.each(paperStems,function(i,stemObj){
        let paperItem ={}
        if(stemObj.questionId){
            paperItem.questionId = stemObj.questionId
            paperItem.origQuestion = 0
            paperItem.questionUrl = stemObj.questionImage
            paperItem.creatorType = stemObj.creatorType
            if(stemObj.creatorId){
                paperItem.creatorId = stemObj.creatorId
            }
        }else{
            paperItem.questionId = null;
            paperItem.origQuestion = 1;
            paperItem.questionUrl = null;
            if(stemObj.periodId){
                paperItem.periodId = stemObj.periodId;
            }
            if(stemObj.periodName){
                paperItem.periodName = stemObj.periodName;
            }
        }
        
        paperItem.stemId = stemObj.stemId;
        
        paper.push(paperItem)
    })
    // console.log('paper is'+JSON.stringify(paper))
    return paper
}


//调用app接口进行toast提示
function h5CallAppShowToast(message){
    if (isIos) {
        try{
            window.webkit.messageHandlers.h5callShowToast.postMessage(message);
        }catch(e){
            console.log('call ios function error:',e)
        }
    } else {
        try{
            xgj.h5callShowToast(message);
        }catch(e){
            console.log('call android function error:',e)
        }   
       
    }
}

function getSimilarTestData() {
    var i = Math.floor((Math.random() * 10) + 1);
    if (i >= 4) {
        return getSimilarTestData();
    }
    var data = stemObj[i];
    var result = {
        "data": data,
        "code": 1
    }
    return result;
}


