//通用题目渲染item
function buildCommonStemItem(stemObj, tagsBar) {
    let stemContent = renderStemContent(stemObj)
    let stemItem = ''
    if(tagsBar){
        let tagBarWrapper =  `<div class="bottom"><div class="tagbar">${tagsBar}</div></div>`
        stemItem = `<div class="stem-item" onclick=clickStem(${stemObj.questionId},${stemObj.x3TeacherId},${stemObj.questionStudentId})>${stemContent}${tagBarWrapper}</div>`    
    }else{
        stemItem = `<div class="stem-item" onclick=clickStem(${stemObj.questionId},${stemObj.x3TeacherId},${stemObj.questionStudentId})>${stemContent}</div>`    

    }
    return stemItem
}
function buildCommonStemItemNoEvent(stemObj, tagsBar){
    let stemContent = renderStemContent(stemObj)
    let stemItem = ''
    if(tagsBar){
        let tagBarWrapper =  `<div class="tagbar">${tagsBar}</div>`
        stemItem = `<div class="stem-item" >${stemContent}${tagBarWrapper}</div>`    
    }else{
        stemItem = `<div class="stem-item" >${stemContent}</div>`    

    }
    return stemItem
}
function renderStemContent(stemObj){
    let stemContent = ' ';
    if (stemObj.stemContent) {
        //有道ocr出来的题目，用Katex加载
        if (stemObj.stemContent.indexOf("latex_yd") != -1) {
            var katexStem = stemObj.stemContent
            var reg = /\$\$latex_yd(.+?)latex_yd\$\$/g;
            while ((result = reg.exec(katexStem)) != null) {
                var rendered = katex.renderToString(result[1], {
                    throwOnError: false
                });
                katexStem = katexStem.replace('\$\$latex_yd' + result[1] + 'latex_yd\$\$', rendered)
            }
            stemContent = katexStem
        } else {//其他来源，用kmathjax加载
            stemContent = stemObj.stemContent;
        }

    } else if (stemObj.questionImage) {
        stemContent = "<img style=\"float:left\" src=\"" + stemObj.questionImage + "\"/>";
    }
    return stemContent
}