 //分组的题目渲染
function buildStemGroupItem(stemGroupObj){
    let stemList = stemGroupObj.reviewPlanList
    let titleStr = stemGroupObj.subjectName+'('+stemList.length+')'
    let groupTitle = `<span class="stem-group-title">${titleStr}</span>`
    let groupContainer = `<div id="stem-group-container-${stemGroupObj.subjectId}" style="margin-top:-10px"></div>`
    let stemGroup =  `<div class="stem-group">${groupTitle}${groupContainer}</div>`
    return stemGroup
}
//生成组里面的题目item
function buildStemInGroup(stemObj,dayType,date){
    // console.log('buildStemInGroup:',dayType,'  finishdate:',stemObj.finishDate,'   date:',date)
    let stemContent = renderStemContent(stemObj)
    let completedBar = ``
    //过去或今天的任务，根据任务状态来显示
    if(dayType === 1 || dayType === 2){
        //已完成或已掌握，则打上“勾勾”标记
        completedBar = `<img  id="reviewed-img-${stemObj.id}" src="../images/review_completed.png" style="display:none;width:32px;height:32px;position:absolute;right:0;bottom:0"/>`;
        // if(stemObj.status === 1 || stemObj.status === 2){
            if(isSameDay(stemObj.finishDate,date)){
                completedBar = `<img  id="reviewed-img-${stemObj.id}" src="../images/review_completed.png" style="width:32px;height:32px;position:absolute;right:0;bottom:0"/>`;
            }
        // }
    } 
    let tagBarWrapper =  `<div class="bottom" style="height:1.3rem"><div class="tagbar"></div></div>`
    stemItem = `<div class="stem-group-item" onclick=clickStemInGroup(${stemObj.id})>${stemContent}${tagBarWrapper}${completedBar}</div>`    
    return stemItem
}
function isSameDay(dateStr1,dateStr2){
    let date1 = new Date(dateStr1)
    let date2 = new Date(dateStr2)
    if(date1.getTime() === date2.getTime()){
        return true
    }
    return false
}
//生成组里面的题目item
function buildStemInGroupOld(stemObj,tagsBar){
    let stemContent = renderStemContent(stemObj)
    let stemItem = ''
    if(tagsBar){
        let tagBarWrapper =  `<div class="bottom"><div class="tagbar">${tagsBar}</div></div>`
        stemItem = `<div class="stem-item" onclick=clickStemInGroup(${stemObj.id})>${stemContent}${tagBarWrapper}</div>`    
    }else{
        let tagBarWrapper =  `<div class="bottom" style="height:1.3rem"><div class="tagbar"></div></div>`
        let completedBar = ``
        switch(stemObj.status){
            case 0:
                completedBar = ``
                break;
            case 1:
                completedBar = `<img  src="../images/review_completed.png" style="width:32px;height:32px;position:absolute;right:0;bottom:0"/>`;
                break;    
        }
        stemItem = `<div class="stem-item" onclick=clickStemInGroup(${stemObj.id})>${stemContent}${tagBarWrapper}${completedBar}</div>`    

    }
    return stemItem
}

function clickStemInGroup(taskId){
    let requestAppParam = JSON.stringify({
        "taskId": taskId,
    })
    console.log('requestappparam:',requestAppParam)
    if (isIos) {
        try{
            window.webkit.messageHandlers.clickStem.postMessage(requestAppParam);
        }catch(e){
            console.log('call ios function error:',e)
        }
    } else {
        try{
            xgj.clickStem(requestAppParam);
        }catch(e){
            console.log('call android function error:',e)
        }
    }
    return false;
}



function completeTask(tasks,index){
    
    if(index <= tasks.length){
        let task = tasks[index]
        // console.log('index:',index,'curid:',task.taskId)
        let reviewedImgId = ''
        if(task){
            reviewedImgId = "#reviewed-img-" + task.taskId
        }
        
        if($(reviewedImgId).is(":hidden")){

            $('html').animate({
                scrollTop : $(reviewedImgId).parent().offset().top-20
            }, 500,'swing',function(){
                // console.log('index b:',index)
                $(reviewedImgId).show()
                index++
                completeTask(tasks,index)
                
            });
        }else{
            // console.log('index c:',index)
            index++
            completeTask(tasks,index)
        }
        
    }else{
        $(".top-box").html("应复习"+tasks.length+"题，已复习"+tasks.length+"题")
    }
}